@header const Vec2 = @Vector(2, f32)
@ctype vec2 Vec2

@vs vs
in vec2 mesh_xy;

in vec2 instance_xbasis;
in vec2 instance_ybasis;
in vec2 instance_origin;
in vec4 instance_color;
in float instance_depth;

uniform Screen {
	vec2 screen_size;
};

out vec4 color;

void main() {
	// Calculate the world position of the vertex
    const vec2 world_position = instance_origin + mesh_xy.x * instance_xbasis + mesh_xy.y * instance_ybasis;

    // Convert world position to normalized device coordinates (NDC)
    // Assuming the screen coordinates range from (0, 0) to (screen_size.x, screen_size.y)
    const vec2 ndc_position = (vec2(world_position.x, -world_position.y) / screen_size) * 2.0 - vec2(1.0, -1.0);

    // Set the position of the vertex in clip space
    gl_Position = vec4(ndc_position, instance_depth, 1.0);

    // Set the output color
    color = instance_color;
}
@end

@fs fs
in vec4 color;
out vec4 texel;

void main() {
	texel = color;
}
@end

@program draw_2d vs fs
